<template>
    <v-container>
        <v-row class="ma-0 ">
            <v-col cols="12">
                <text-component :text="`You have ${gamePoint} point...`" :textColor="'red--text'" />
            </v-col>
            <GameSection v-if="role.length !== 0" :imgs="role" />
            <v-col cols="12">
                <text-component :text="result" />
            </v-col>
            <v-col cols="12">
                <Button :color="'green'" :text="'Start...'" :block="true" @clicked="startGame" />
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
import GameSection from '~/components/GameSection.vue';
import Button from '~/components/Button.vue';
import { roleItems } from '~/data/roleItems';
import TextComponent from '~/components/TextComponent.vue';
import { mapState, mapMutations } from "vuex"
import { match } from 'assert';
export default {
    components: { GameSection, Button, TextComponent },
    data() {
        return {
            role: [],
            roleItems,
            result: ""
        }
    },
    computed: {
        ...mapState({
            gamePoint: state => state.gameResult.gamePoint
        })
    },
    methods: {
        startGame() {
            if (this.gamePoint === 0) {
                return this.result = "You don't have credit for playing..."
            }
            this.role = []
            this.decreaseGamePint()
            for (let i = 0; i < 3; i++) {
                let rndDigit = Math.floor(Math.random() * 4) + 1
                this.roleItems.forEach(item => {
                    if (item.id === rndDigit) {
                        this.role.push(item.icon)
                    }
                });
            }
            this.gameResult()
        },
        gameResult() {
            let img = this.role[0]
            if (this.role[1] === img && this.role[2] === img) {
                let point = this.gamePoint
                let value = null
                if (point > 40 && point < 60) {
                    value = Math.floor((point * 30) / 100)
                    this.increaseGamePint(this.gamePoint + value)
                } else if (point > 60) {
                    value = Math.floor((point * 60) / 100)
                    this.increaseGamePint(this.gamePoint + value)
                } else {
                    value = this.gamePoint
                    this.increaseGamePint(value + value)
                }
                return this.result = "Congratulations!"
            }
            this.result = ""
        },
        ...mapMutations({
            decreaseGamePint: "gameResult/decreaseGamePint",
            increaseGamePint: "gameResult/increaseGamePint",
        })
    }
}
</script>